image: openjdk:8-alpine

stages:
    - build
    - test
    - quality

cache:
    key: "$CI_JOB_NAME"
    paths:
        - .m2/repository
        - .sonar/cache
variables:
  MAVEN_OPTS: "-Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dhttps.protocols=TLSv1.2"
       
build_job:
    stage: build
    script:
        - ./mvnw compile --batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true

test_job:
    stage: test
    script:
       - ./mvnw test --batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true

code_quality_job_sonar:
    stage: quality
    script: ./mvnw verify sonar:sonar -Dsonar.login="$SONAR_TOKEN" -Dsonar.qualitygate.wait=true -Dsonar.gitlab.quality_gate_fail_mode="error"

code_quality_job_codeclimate:
    stage: quality
    image: docker:stable
    allow_failure: true
    services:
        - docker:stable-dind
    script:
        - mkdir codequality-results
        - docker run
            --env CODECLIMATE_CODE="$PWD"
            --volume "$PWD":/code
            --volume /var/run/docker.sock:/var/run/docker.sock
            --volume /tmp/cc:/tmp/cc
            codeclimate/codeclimate analyze -f html > ./codequality-results/index.html
    artifacts:
        paths:
        - codequality-results/
